'PONG!
'
'Based on source code of PING! by Noah Daleo.
'
DEFINT A-Z
DECLARE SUB drawbg ()
DECLARE SUB delay ()
DECLARE SUB showscore (score1a%, score2a%)
DECLARE SUB erasescore ()
DIM SHARED score1%, score2%

'Start of Mouse
'***
    DECLARE SUB Mouse (cx, dx, bx)
    DECLARE SUB MousePointer (SW)
    DIM SHARED a(9)                 'Set up array for code
                                                          
    DEF SEG = VARSEG(a(0))          'Get array segment (nnnn:    )
                                    '    (two 8 bit)
    FOR i = 0 TO 17                 'length of DATA to
       READ r                       'read
       POKE VARPTR(a(0)) + i, r     'into array/2 (nnnn:iiii) (one 8 bit)
    NEXT i                          'until 17

'**************************** Machine Code *********************************

DATA &HB8,&H00,&H00   :   ' mov  AX,[n]       [Swap code-(L),(H)] in AX
DATA &H55             :   ' push BP           Save BP
DATA &H8B,&HEC        :   ' mov  BP,SP        Get BP to c Seg
DATA &HCD,&H33        :   ' int  33           Interrupt 33
DATA &H92             :   ' xchg AX,[reg]     [Swap code-reg] in AX
DATA &H8B,&H5E,&H06   :   ' mov  BX,[BP+6]    Point to (variable)
DATA &H89,&H07        :   ' mov  [BX],AX      Put AX in (variable)
DATA &H5D             :   ' pop  BP           Restore BP
DATA &HCA,&H02,&H00   :   ' ret  2            Far return
CALL MousePointer(0)
CALL MousePointer(3)
'End of Mouse

'
' Read command line options
'
line$ = COMMAND$
FOR x = 1 TO LEN(line$) - 1
part$ = MID$(line$, x, 2)
part$ = UCASE$(part$)
IF part$ = "-D" OR part$ = "/D" AND x <> LEN(line$) - 1 THEN paddlesize% = VAL(MID$(line$, x + 2, 1))
IF part$ = "-?" OR part$ = "/?" THEN part$ = "-H"
IF part$ = "-H" OR part$ = "/H" THEN
CLS
PRINT "Command line options"
PRINT : PRINT "Help: -?, /?, -h, /h"
PRINT : PRINT "Difficulty: -d#, /d#"
PRINT "# is between 0-5, 0 = Easy  5 = Hard "
PRINT
END
END IF
NEXT x

credits% = 0
startspeed% = 5
'paddlesize% (0-5)
paddlesize% = paddlesize% + 10

10
score1% = 0
score2% = 0
CLS
SCREEN 1
'PEN ON                       ' Swap with Call Mouse line for old driver
'pv1 = PEN(5): pv2 = pv1 + 1  ' Swap with pv1 = cx line for old driver
CALL Mouse(cx, dx, bx)
pv1 = cx: pv2 = pv1 + 1
ev1 = 100: ev2 = ev1 + 1
bh = 160
bv = 100
RANDOMIZE TIMER
gh = INT(RND * 2) + 1
baddh = -1
IF gh = 1 THEN baddh = 1
RANDOMIZE TIMER
this = INT(RND * 2) + 1
baddv = RND * -1
IF this = 1 THEN baddv = RND
speed% = startspeed%
DO
CALL Mouse(cx, dx, bx)        ' Remove for old driver
'pv1 = PEN(5)                 ' Swap with pv1 = cx line for old driver
pv1 = cx
CALL drawbg
'ev2 = old paddle Y postion
'ev1 = new paddle Y postion
IF pv1 <> pv2 THEN LINE (20, pv2 - 10)-(25, pv2 + 10), 0, BF
IF ev1 <> ev2 THEN LINE (300, ev2 - 10)-(295, ev2 + 10), 0, BF
IF pv1 <> pv2 OR bh <= 30 THEN LINE (20, pv1 - 10)-(25, pv1 + 10), 15, BF
IF ev1 <> ev2 OR bh >= 290 THEN LINE (300, ev1 - 10)-(295, ev1 + 10), 15, BF
LINE (bh - 2, bv - 2)-(bh + 2, bv + 2), 15, BF
delay
LINE (bh - 2, bv - 2)-(bh + 2, bv + 2), 0, BF
pv2 = pv1: ev2 = ev1
bh = bh + (baddh * speed%)
bv = bv + baddv
'
IF credits% <> 0 THEN
IF bh > 20 AND bh < 27 AND bv > pv1 - 14 AND bv < pv1 + 14 THEN
SOUND 750, 1
baddh = ABS(baddh)
baddv = (pv1 - bv) * -1
END IF
END IF
'
IF bh < 0 THEN
IF credits% <> 0 THEN
erasescore
SOUND 250, 4
SOUND 100, 6
score2% = score2% + 1
END IF
bh = 160
bv = 100
RANDOMIZE TIMER
gh = INT(RND * 2) + 1
baddh = -1
IF gh = 1 THEN baddh = 1
RANDOMIZE TIMER
this = INT(RND * 2) + 1
baddv = RND * -1
IF this = 1 THEN baddv = RND
speed% = startspeed%
IF score2% = 15 AND credits% <> 0 THEN credits% = 0
END IF
'
IF bh > 320 THEN
IF credits% <> 0 THEN
erasescore
SOUND 100, 4
SOUND 250, 6
score1% = score1% + 1
END IF
bh = 160
bv = 100
RANDOMIZE TIMER
gh = INT(RND * 2) + 1
baddh = -1
IF gh = 1 THEN baddh = 1
RANDOMIZE TIMER
this = INT(RND * 2) + 1
baddv = RND * -1
IF this = 1 THEN baddv = RND
speed% = startspeed%
IF score1% = 15 AND credits% <> 0 THEN credits% = 0
END IF
'
IF bv < 4 THEN bv = 4: baddv = baddv * -1
IF bv > 195 THEN bv = 195: baddv = baddv * -1
enemyaccuracy = ABS(ev1 - bv) + baddv
IF bv < ev1 AND bh > 160 THEN ev1 = ev1 - enemyaccuracy
IF bv > ev1 AND bh > 160 THEN ev1 = ev1 + enemyaccuracy
IF ev1 > 199 THEN ev1 = 199
IF ev1 < 0 THEN ev1 = 0
'
IF bh > 295 AND bh < 302 AND bv > ev1 - paddlesize% AND bv < ev1 + paddlesize% THEN
IF credits% <> 0 THEN SOUND 500, 1
baddh = baddh * -1
baddv = ABS(ev1 - bv)
END IF
'
KEY$ = INKEY$
IF KEY$ = CHR$(13) AND credits% = 0 THEN credits% = 1: GOTO 10
LOOP UNTIL KEY$ = CHR$(27)
END

DEFSNG A-Z
SUB delay
at! = TIMER
DO
LOOP UNTIL TIMER <> at!
END SUB

SUB drawbg
FOR it = 1 TO 200 STEP 10
LINE (158, it)-(162, it + 6), 15, BF
NEXT it
showscore score1%, score2%
END SUB

SUB erasescore

LINE (69, 10)-(91, 35), 0, BF
LINE (227, 10)-(249, 35), 0, BF

END SUB

DEFINT A-Z
SUB Mouse (cx, dx, bx)
        
           POKE VARPTR(a(4)), &H92           'Swap code,Get CX setup
          CALL absolute(cx, VARPTR(a(0)))     'Run Code
'              cx = cx / 8                     'Adjust 25x80
           POKE VARPTR(a(4)), &H91           'Swap code,Get DX setup
          CALL absolute(dx, VARPTR(a(0)))     'Run Code
'              dx = dx / 8                     'Adjust 25x80
           POKE VARPTR(a(4)), &H93           'Swap code,Get BX setup
          CALL absolute(bx, VARPTR(a(0)))     'Run Code

                                   'Note :
                                   'Remove the /8
                                   'for graphics modes.


END SUB

SUB MousePointer (SW)
        
           POKE VARPTR(a(0)) + 1, SW         'Swap code,Set AX = (SW)
          CALL absolute(c, VARPTR(a(0)))     'Run Code

                                          'Note:
                                             'SW = 0-reset
                                             'SW = 1-on
                                             'SW = 2-off
                                             'SW = 3-coordinate


END SUB

DEFSNG A-Z
SUB showscore (score1a%, score2a%)
IF score1a% >= 10 THEN
LINE (57, 10)-(59, 35), 15, BF
END IF
IF score1a% = 0 OR score1a% = 10 THEN
LINE (69, 10)-(89, 12), 15, BF
LINE (69, 10)-(71, 35), 15, BF
LINE (89, 33)-(71, 35), 15, BF
LINE (89, 35)-(91, 10), 15, BF
END IF
IF score1a% = 1 OR score1a% = 11 THEN
LINE (89, 10)-(91, 35), 15, BF
END IF
IF score1a% = 2 OR score1a% = 12 THEN
LINE (69, 10)-(89, 12), 15, BF
LINE (91, 20)-(89, 10), 15, BF
LINE (91, 20)-(69, 22), 15, BF
LINE (71, 20)-(69, 33), 15, BF
LINE (91, 33)-(69, 35), 15, BF
END IF
IF score1a% = 3 OR score1a% = 13 THEN
LINE (69, 10)-(89, 12), 15, BF
LINE (91, 33)-(89, 10), 15, BF
LINE (91, 20)-(69, 22), 15, BF
LINE (91, 33)-(69, 35), 15, BF
END IF
IF score1a% = 4 OR score1a% = 14 THEN
LINE (89, 10)-(91, 35), 15, BF
LINE (91, 20)-(69, 22), 15, BF
LINE (71, 10)-(69, 22), 15, BF
END IF
IF score1a% = 5 OR score1a% = 15 THEN
LINE (89, 20)-(91, 35), 15, BF
LINE (91, 20)-(69, 22), 15, BF
LINE (71, 10)-(69, 22), 15, BF
LINE (91, 33)-(69, 35), 15, BF
LINE (69, 10)-(91, 12), 15, BF
END IF
IF score1a% = 6 THEN
LINE (89, 20)-(91, 35), 15, BF
LINE (91, 20)-(69, 22), 15, BF
LINE (71, 10)-(69, 33), 15, BF
LINE (91, 33)-(69, 35), 15, BF
LINE (69, 10)-(91, 12), 15, BF
END IF
IF score1a% = 7 THEN
LINE (89, 10)-(91, 35), 15, BF
LINE (91, 10)-(69, 12), 15, BF
END IF
IF score1a% = 8 THEN
LINE (89, 10)-(91, 35), 15, BF
LINE (91, 20)-(69, 22), 15, BF
LINE (71, 10)-(69, 33), 15, BF
LINE (91, 33)-(69, 35), 15, BF
LINE (69, 10)-(91, 12), 15, BF
END IF
IF score1a% = 9 THEN
LINE (89, 10)-(91, 35), 15, BF
LINE (91, 20)-(69, 22), 15, BF
LINE (71, 10)-(69, 22), 15, BF
'LINE (91, 33)-(69, 35), 15, BF
LINE (69, 10)-(91, 12), 15, BF
END IF
IF score2a% >= 10 THEN
LINE (215, 10)-(217, 35), 15, BF
END IF
IF score2a% = 0 OR score2a% = 10 THEN
LINE (227, 10)-(247, 12), 15, BF
LINE (227, 10)-(229, 35), 15, BF
LINE (247, 33)-(229, 35), 15, BF
LINE (247, 35)-(249, 10), 15, BF
END IF
IF score2a% = 1 OR score2a% = 11 THEN
LINE (247, 10)-(249, 35), 15, BF
END IF
IF score2a% = 2 OR score2a% = 12 THEN
LINE (227, 10)-(247, 12), 15, BF
LINE (249, 20)-(247, 10), 15, BF
LINE (249, 20)-(227, 22), 15, BF
LINE (229, 20)-(227, 33), 15, BF
LINE (249, 33)-(227, 35), 15, BF
END IF
IF score2a% = 3 OR score2a% = 13 THEN
LINE (227, 10)-(247, 12), 15, BF
LINE (249, 33)-(247, 10), 15, BF
LINE (249, 20)-(227, 22), 15, BF
LINE (249, 33)-(227, 35), 15, BF
END IF
IF score2a% = 4 OR score2a% = 14 THEN
LINE (247, 10)-(249, 35), 15, BF
LINE (249, 20)-(227, 22), 15, BF
LINE (229, 10)-(227, 22), 15, BF
END IF
IF score2a% = 5 OR score2a% = 15 THEN
LINE (247, 20)-(249, 35), 15, BF
LINE (249, 20)-(227, 22), 15, BF
LINE (229, 10)-(227, 22), 15, BF
LINE (249, 33)-(227, 35), 15, BF
LINE (227, 10)-(249, 12), 15, BF
END IF
IF score2a% = 6 THEN
LINE (247, 20)-(249, 35), 15, BF
LINE (249, 20)-(227, 22), 15, BF
LINE (229, 10)-(227, 33), 15, BF
LINE (249, 33)-(227, 35), 15, BF
LINE (227, 10)-(249, 12), 15, BF
END IF
IF score2a% = 7 THEN
LINE (247, 10)-(249, 35), 15, BF
LINE (249, 10)-(227, 12), 15, BF
END IF
IF score2a% = 8 THEN
LINE (247, 10)-(249, 35), 15, BF
LINE (249, 20)-(227, 22), 15, BF
LINE (229, 10)-(227, 33), 15, BF
LINE (249, 33)-(227, 35), 15, BF
LINE (227, 10)-(249, 12), 15, BF
END IF
IF score2a% = 9 THEN
LINE (247, 10)-(249, 35), 15, BF
LINE (249, 20)-(227, 22), 15, BF
LINE (229, 10)-(227, 22), 15, BF'
'LINE (249, 33)-(227, 35), 15, BF
LINE (227, 10)-(249, 12), 15, BF
END IF
END SUB

